         TITLE ANALYSE DE FICHIER
         PAGELEN 72


* Analyse de fichiers,par C.TRONCHE (87124) 1987,1988
* Bibliothque QLCF
* Version 1.00 du 17/04/1988
*
* Ce programme permet le compactage de fichiers texte (avec destruction de la
* ponctuation).Le travail se fait toujours par rapport au dictionnaire courant,
* stock en mmoire.
* La liste des chanes est stocke  partir de WORKSPAC (au dbut de la zone de
* mmoire alloue au programme) jusqu' STRINGTP.La table des pointeurs est stocke
* a l'autre extrmit de la plage mmoire.Elle est pointe en bas par POINTBT et en
* haut par LASTPOINT (qui pointe le dernier lment,c'est  dire 4 octets sous la
* dernire adresse de la plage mmoire.Les pointeurs de la table sont relatifs 
* A6.

         INCLUDE RAM1_QDOS1_IN
         INCLUDE RAM1_QDOS2_IN
         INCLUDE RAM1_QDOSUT_IN

****************
** CONSTANTES **
****************

JOB_CURR EQU -1              Numro du job courant
INFINITE EQU -1              Temporisation infinie
STRGCOMP EQU 0               Type comparaison de chanes
MAXLEN   EQU 32              Longueur maximale d'un mot+1

END_MARK EQU 0               Marque la fin de la liste des STOPS
LINEFEED EQU 10              Caractre LINE FEED

************************
** VARIABLES SYSTEMES **
************************

STRINGTP EQU $0    Long      Haut de la liste des chaines
WORDNUM  EQU $4    Mot       Nombre de mots
POINTBT  EQU $6    Long      Base de la table des pointeurs
FILEIN   EQU $A    Long      Id du fichier d'entre
FILESAVE EQU $E    Long      Sauvegarde de l'Id de fichier
FILEOUT  EQU $12   Long      Id du fichier de sortie
LASTPOIN EQU $16   Long      Adresse du dernier pointeur
CONSOLID EQU $1A   Long      Identificateur de la console
LASTBUFF EQU $1E   octet*34  Dernier mot (au cours du compactage)
WORKSPAC EQU $40   Long      Adresse de la liste des mots
POINTADR EQU $44   Long      Adresse du sommet de la liste des pointeurs
******** EQU $48   Long
DICO     EQU $4C   octet*34  Nom du dictionnaire
FILENAME EQU $6E   octet*34  Nom du fichier

ENDVAR   EQU $90

****************
** NOM DU JOB **
****************

         BRA.S BEGIN
         NOP
         NOP
         DC.W $4AFB,12
         DC.B 'WORD SCANNER'

********************
** INITIALISATION **
********************

BEGIN    SUBA.L #ENDVAR,SP             Rserve de l'espace pour les variables systmes
         MOVEA.L SP,A6                 Variables systmes
         MOVE.L #-1,FILEIN(A6)         Met FILEIN et FILEOUT  -1 pour viter de
         MOVE.L #-1,FILEOUT(A6)          fermer la console 0
         LEA CONSOLE,A1                Ouverture de la console
         MOVEA UT.CON,A5
         JSR (A5)
         TST D0
         BNE RETURN
         MOVE.L A0,CONSOLID(A6)
         LEA ASKMEMTX,A1               Demande la taille mmoire
         MOVEA UT.MTEXT,A5
         JSR (A5)
         LEA FILENAME(A6),A1           Saisie de la taille mmoire
         MOVEQ #MAXLEN,D2
         MOVEQ #INFINITE,D3
         MOVEQ #IO.FLINE,D0
         TRAP #3
         TST D0
         BNE RETURN
         LEA FILENAME(A6),A0           Pointe le nombre ASCII
         SUBA.L A6,A0                  Rendu relatif
         MOVEA.L SP,A1                 Pile utilise comme pile arithmtique
         SUBQ #2,SP                    Rserve un mot pour le rsultat
         SUBA.L A6,A1                  Rendu relatif
         MOVEA CN.DTOI,A5
         JSR (A5)
         MOVE (SP)+,D1
         TST D0
         BEQ.S OKNUM
         MOVEQ #50,D1                  Valeur par dfaut=50 K
OKNUM    MULU #1024,D1                 Taille de l'espace mmoire
         MOVE.L D1,D7                  Sauv dans D7
         MOVEQ #JOB_CURR,D2
         MOVEQ #MT.ALCHP,D0
         TRAP #1
         TST D0                        Problme?
         BNE RETURN                      ->sortie
         MOVE.L A0,WORKSPAC(A6)        Sauve l'adresse de la zone de travail
         ADDA.L D7,A0                  Adresse de la table des pointeurs
         MOVE.L A0,POINTADR(A6)
         SUBQ #4,A0                    Adresse du dernier pointeur
         MOVE.L A0,LASTPOIN(A6)
         MOVE.L #$00010A00,DICO(A6)
MAINLOOP MOVEA.L CONSOLID(A6),A0
         LEA DICOTEXT,A1
         MOVEA UT.MTEXT,A5
         JSR (A5)
         LEA DICO(A6),A1
         JSR (A5)
         MOVEQ #LINEFEED,D1
         MOVEQ #INFINITE,D3
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         LEA MENU,A1
         JSR (A5)
FETCHCOM MOVEQ #SD.CURE,D0
         TRAP #3
         MOVEQ #IO.FBYTE,D0
         TRAP #3
         MOVEQ #SD.CURS,D0
         TRAP #3
         CMP.B #250,D1                 Si SHIFT+F5
         BEQ REFRESH                     ->rafrachissement de l'cran
         CMP.B #'0',D1
         BLT.S FETCHCOM
         CMP.B #'6',D1
         BGE.S FETCHCOM
         SUB.B #48,D1
         EXT D1
         ADD D1,D1
         MOVE TABLECOM(PC,D1),D1
         JMP TABLECOM(PC,D1)

RETURN   MOVE D0,D7
         LEA ENDTEXT,A1
         SUBA.L A0,A0
         MOVEA UT.MTEXT,A5
         JSR (A5)
         MOVE D7,D0
         EXT.L D0
         MOVEA UT.ERR0,A5
         JSR (A5)
         MOVEQ #0,D3
         MOVEQ #JOB_CURR,D1
         MOVEQ #MT.FRJOB,D0
         TRAP #1
         BRA.S RETURN

TABLECOM DC.W RETURN-TABLECOM
         DC.W COMPACOM-TABLECOM
         DC.W UNCOMCOM-TABLECOM
         DC.W WRTDICOM-TABLECOM
         DC.W COMDICOM-TABLECOM
         DC.W UNCDICOM-TABLECOM

CONSOLE  DC.B 156,1,0,7
         DC.W 196,252,116,0
DICOTEXT DC.W  22
         DC.B 'Dictionnaire courant:',LINEFEED
MENU     DC.W  142
         DC.B '0-SORTIE',LINEFEED
         DC.B '1-Compactage du texte',LINEFEED
         DC.B '2-Dcompactage du texte',LINEFEED
         DC.B '3-Ecriture du dictionnaire',LINEFEED
         DC.B '4-Compactage du dictionnaire',LINEFEED
         DC.B '5-Dcompactage du dictionnaire',LINEFEED
ENDTEXT  DC.W  35
         DC.B 'Traitement du dictionnaire termin',LINEFEED,0
ASKMEMTX DC.W 26
         DC.B 'Taille de l',39,'espace en K ?',LINEFEED

***************
** COMMANDES **
***************

* Dcompactage du dictionnaire

UNCDICOM BSR QUERYDIC
         CLR D0
         BRA EXIT

* Compactage du dictionnaire

COMDICOM LEA ASKDNTEX,A1
         MOVEQ #IO.NEW,D7
         BSR QUERYFIL
         MOVE.L A0,FILEOUT(A6)
         BSR COMPACT
         CLR D0
         BRA EXIT

* Ecriture du dictionnaire

WRTDICOM LEA ASKDNTEX,A1
         MOVEQ #IO.NEW,D7
         BSR QUERYFIL
         BSR WRITEDIC
         MOVEQ #IO.CLOSE,D0
         TRAP #2
         BRA MAINLOOP

ASKDNTEX DC.W 22
         DC.B 'Nom du dictionnaire :',LINEFEED

* Rtablit le fichier initial

UNCOMCOM BSR QUERYDIC
         LEA SOURCTEX,A1
         MOVEQ #IO.SHARE,D7
         BSR QUERYFIL
         MOVE.L A0,FILEIN(A6)
         LEA TARGETEX,A1
         MOVEQ #IO.NEW,D7
         BSR QUERYFIL
         MOVE.L A0,FILEOUT(A6)
         BSR RESTORE
         CLR D0
         BRA EXIT

* Compacte le fichier

COMPACOM BSR QUERYDIC
         LEA SOURCTEX,A1
         MOVEQ #IO.SHARE,D7
         BSR QUERYFIL
         MOVE.L A0,FILEIN(A6)
         LEA TARGETEX,A1
         MOVEQ #IO.NEW,D7
         BSR QUERYFIL
         MOVE.L A0,FILEOUT(A6)
         MOVEA.L FILEIN(A6),A0
         BSR LPEXWORD                  Extraction des mots et rangement dans le dictionnaire
         MOVE WORDNUM(A6),D1           Affiche le nombre de nouveaux mots du dictionnaire
         MOVEA.L CONSOLID(A6),A0
         MOVEA UT.MINT,A5
         JSR (A5)
         LEA WRDNUMTX,A1
         MOVEA UT.MTEXT,A5
         JSR (A5)
         MOVEA.L FILEIN(A6),A0
         MOVEQ #0,D1
         MOVEQ #INFINITE,D3
         MOVEQ #FS.POSAB,D0            Repositionne au dbut du fichier
         TRAP #3
         TST D0
         BNE EXIT
         BSR TRANSCRI                  Cration du fichier des pointeurs
         MOVEA.L FILEOUT(A6),A0
         MOVEQ #IO.CLOSE,D0
         TRAP #2
         TST D0
         BNE EXIT
         TST WORDNUM(A6)
         BEQ.S EXITPACM
         LEA DICO(A6),A0
         MOVEQ #IO.NEW,D3
         BSR OPENFILE
         MOVE.L A0,FILEOUT(A6)
         BSR COMPACT
EXITPACM CLR D0
         BRA EXIT

SOURCTEX DC.W 19
         DC.B 'Nom de la source ?',LINEFEED,0
TARGETEX DC.W 24
         DC.B 'Nom de la destination ?',LINEFEED
WRDNUMTX DC.W 14
         DC.B ' mots ajouts',LINEFEED

*****************************************************************************
** RESTITUTION DU FICHIER FILTRE A PARTIR DES POINTEURS ET DU DICTIONNAIRE **
*****************************************************************************

RESTORE  LEA RESTOTEX,A5
         BSR DISPNAME
         MOVEQ #INFINITE,D3
RESTORLP MOVEA.L FILEIN(A6),A0         Saisie du premier octet du pointeur
         MOVEQ #IO.FBYTE,D0
         TRAP #3
         TST D0
         BNE EXITNEOF                  Si EOF sortie
         MOVE.B D1,D7                  Stocke l'octet
         LSL #8,D7                     Fait de la place pour le 2eme octet
         MOVEQ #IO.FBYTE,D0            Saisie du 2eme octet
         TRAP #3
         TST D0                        Si erreur sortie
         BNE EXIT
         MOVE.B D1,D7
         MOVE D7,A1
         ADDA.L A1,A1
         ADDA.L A1,A1
         ADDA.L POINTBT(A6),A1
         MOVEA.L (A1),A1
         ADDA.L A6,A1
         MOVEA.L FILEOUT(A6),A0
         MOVEA UT.MTEXT,A5
         JSR (A5)
         TST D0
         BNE EXIT
         MOVEQ #' ',D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0
         BNE EXIT
         BRA.S RESTORLP

RESTOTEX DC.W 21
         DC.B 'Restitution du texte',LINEFEED,0

**********************************
** DECOMPACTAGE DU DICTIONNAIRE **
**********************************

UNPACK   LEA UNPACKTX,A5
         BSR DISPNAME
         BSR INILIST                   Initialise les listes
         MOVEA.L STRINGTP(A6),A2       A2=sommet des chanes
         MOVEA.L POINTBT(A6),A3        A3=base des pointeurs
         MOVE.L (A3)+,D7               Supprime l'lment de longueur 0
         MOVEQ #INFINITE,D3
         MOVEQ #0,D4                   Longueur du mot
UPFETCLP MOVEQ #IO.FBYTE,D0            Boucle de saisie
         TRAP #3                       Saisit un caractre
         TST D0
         BNE EXITUNPA
         CMP.B #MAXLEN,D1              Si <=32
         BLS.S NEWWORD                   ->nouveau mot
         MOVE.B D1,2(A2,D4)            Sinon,stocke le caractre
         ADDQ #1,D4
         BRA.S UPFETCLP                  et continue

NEWWORD  MOVE D4,(A2)                  Stocke la taille
         MOVEA.L A2,A1                 Adresse de la chane dans A1
         SUBA.L A6,A1                  Rendue relative  A6
         MOVE.L A1,-(A3)               Stocke dans la zone des pointeurs
         ADDQ #3,D4                    Longueur arrondie  2 par excs+2
         BCLR #0,D4
         MOVEA.L A2,A1                 Adresse sauve dans A1
         ADDA D4,A2                    Adresse de la chane suivante
         MOVE.L A2,D4                  Stocke dans D4
         CMP.L POINTBT(A6),D4          Si >= au bas de la table des pointeurs
         BGE OUTOFMEM                    ->"out of memory"
         EXT D1
         MOVE D1,D4                    Si 0 caractres identiques au mot prcdent
         BEQ.S UPFETCLP                  ->suite
         MOVE D1,D4                    Longueur du prochain mot
         SUBQ #1,D1                    Compteur de boucle
UNPALP00 MOVE.B 2(A1,D1),2(A2,D1)      Transfert
         DBRA D1,UNPALP00
         BRA.S UPFETCLP

EXITUNPA CMP #ERR.EF,D0                Fin du fichier ?
         BNE EXIT                        ->non,erreur
         MOVE D4,(A2)                  Stocke la taille de la dernire chane
         ADDQ #3,D4                    Adresse de la future chane
         BCLR #0,D4
         MOVEA.L A2,A1
         ADDA D4,A2
         SUBA.L A6,A1                  Relativise l'adresse
         MOVE.L A1,-(A3)               Stocke le pointeur
         MOVE.L D7,-(A3)               Rtablit le plus petit lment
         MOVE.L A2,STRINGTP(A6)        Met  jour le pointeur de chane
         MOVE.L A3,POINTBT(A6)           et le pointeur des pointeurs !
         MOVEQ #IO.CLOSE,D0            Ferme la source
         TRAP #2
         ADDQ #4,A3                    Pointe le premier lment suprieur au plus petit
         MOVEA.L LASTPOINT(A6),A0
         MOVE.L A0,D0
         SUB.L A3,D0
         LSR.L #3,D0                   Calcule le nombre de pointeurs divis par 2
         SUBQ #1,D0
INVEPOIN MOVE.L (A3),D1                Inverse le dictionnaire,en effet les mots qui
         MOVE.L -(A0),(A3)+              ont t lus dans le compact taient dans
         MOVE.L D1,(A0)                  l'ordre et ils ont t empils par prdcrmentation,
         DBRA D0,INVEPOIN                ils taient donc jusqu'ici dans l'ordre inverse
         RTS

UNPACKTX DC.W 32
         DC.B 'Dcompactage du dictionnaire',LINEFEED,'==>'


******************************
** TRANSCRIPTION DU FICHIER **
******************************

TRANSCRI LEA TRANSCTX,A5
         BSR DISPNAME
TRANSCLP LEA FILENAME(A6),A1           Boucle de transcription
         MOVEA.L FILEIN(A6),A0
         BSR GETWORD                   Saisie d'un mot
         TST D0
         BNE EXITNEOF
         SUBA.L A6,A1                  Rend A1 relatif
         MOVEA.L POINTBT(A6),A2        Base de la recherche dichotomique
         MOVEA.L LASTPOIN(A6),A3       Haut de la dichotomie
         MOVEA UT.CSTR,A5              Vecteur de comparaison de chanes
TRANSDIC MOVE.L A3,D0
         SUB.L A2,D0
         LSR.L #1,D0                   Calcule le milieu de la table
         AND #$FFFC,D0                 Arrondi aux 4 infrieurs
         MOVEA.L A2,A4
         ADDA.L D0,A4                  Calcule de l'adresse du milieu de la table
         MOVEA.L (A4),A0               Adresse de la chane (relative  A6)
         MOVEQ #STRGCOMP,D0            Compare les chane
         JSR (A5)
         TST D0                        Rsultat ?
         BEQ.S WRITEPOI                Si gales -> criture du pointeur
         BLT.S SUPPART
         MOVEA.L A4,A3                 Moiti infrieure
         BRA.S TRANSDIC

SUPPART  MOVEA.L A4,A2                 Moiti suprieure
         BRA.S TRANSDIC

WRITEPOI SUBA.L POINTBT(A6),A4         Position dans la table
         MOVE.L A4,D7                  Stocke dans D7
         LSR.L #2,D7                     divise par 4 (donc numro du pointeur)
         MOVEA.L FILEOUT(A6),A0
         MOVEQ #INFINITE,D3
         MOVE D7,D1
         LSR #8,D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0
         BNE EXIT
         MOVE.B D7,D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0
         BNE EXIT
         BRA.S TRANSCLP

TRANSCTX DC.W 14
         DC.B 'Transcription',LINEFEED,0

********************************
** COMPACTAGE DU DICTIONNAIRE **
********************************

COMPACT  LEA COMPACTX,A5
         BSR DISPNAME
         MOVEA.L FILEOUT(A6),A0        Nom du fichier de sortie
         MOVEA.L POINTBT(A6),A4        A4=pointeur de chane
         ADDQ #4,A4
         MOVEA.L (A4)+,A1              Adresse de la premire chane
         ADDA.L A6,A1                  Rendue absolue
         MOVEA.L A1,A3                 Sauvegarde dans A3 (adresse de la dernire chane)
         MOVEA UT.MTEXT,A5
         JSR (A5)                      Ecriture dans le fichier de sortie
         TST D0
         BNE EXIT
         MOVEQ #INFINITE,D3            Temporisation
         MOVE (A3)+,D7                 Longueur du dernier mot dans D7
COPYCURR MOVEQ #0,D2                   Compteur de correspondance
         MOVEA.L (A4)+,A2              Adresse de la chane courante
         CMPA.L LASTPOINT(A6),A4       Tout le dictionnaire a t pass ?
         BGT.S EXITCOMP                  ->oui,sortie
         ADDA.L A6,A2                  Adresse de la chane courante rendue absolue
COUNREDU MOVE.B 2(A2,D2),D0
         CMP.B 0(A3,D2),D0             Correspondance ?
         BNE.S PRPACSTR                  ->nom copie le mot courant dans le fichier
         ADDQ #1,D2
         CMP D2,D7           Si corespondance<LEN(dernier mot)
         BGT.S COUNREDU        ->continue
PRPACSTR MOVEQ #IO.SBYTE,D0  Copie le nombre de redondances
         MOVE.B D2,D1
         TRAP #3
         TST D0
         BNE EXIT
         MOVE (A2)+,D7       D7=longueur du nouveau dernier mot (i.e:le mot courant)
         MOVEA.L A2,A3       A3=adresse du nouveau dernier mot
         LEA 0(A2,D2),A1     Adresse du premier caractre non redondant
         SUB D7,D2           Envoie tous les caractres non redondants
         NEG D2
         MOVEQ #IO.SSTRG,D0
         TRAP #3
         TST D0
         BNE EXIT
         BRA.S COPYCURR

EXITCOMP RTS

COMPACTX DC.W 27
         DC.B 'Compactage du dictionnaire',LINEFEED,0


**************************
** PREFILTRAGE DU TEXTE **
**************************

LPEXWORD MOVEA.L STRINGTP(A6),A1       Boucle d'extraction d'un mot
         MOVEA.L FILEIN(A6),A0
         BSR GETWORD                   Extraction du mot
         TST D0
         BNE EXITNEOF
         CMPA.L POINTBT(A6),A1
         BGE OUTOFMEM
         BSR INSERT                    Insertion dans le dictionnaire
         BRA.S LPEXWORD                Suite

OUTOFMEM MOVEQ #ERR.OM,D0              Erreur "Out of memory"
         BRA RETURN                    Fin du programme

**************************************
** Positionnement au dbut d'un mot **
**************************************

SEEKCHAR MOVEQ #INFINITE,D3            Saisie d'un caractre
         MOVEQ #IO.FBYTE,D0
         TRAP #3
         TST D0                        Problme?
         BNE.S EXITSEEK                  ->sortie
         LEA STOPS,A2                  Compare avec la table des caractres
LOOPSEEK CMP.B (A2),D1                   d'arrt
         BEQ.S SEEKCHAR                =? oui->caractre suivant
         CMPI.B #END_MARK,(A2)+        Fin de la liste?
         BNE.S LOOPSEEK                  non,essaie un nouveau marqueur
         CLR D0                          oui,retour sans problme
EXITSEEK RTS

*************************
** Extraction d'un mot **
*************************

GETWORD  MOVEA.L A1,A3
         BSR.S SEEKCHAR                Recherche du dbut
         TST D0
         BNE.S EXITGET
         MOVEQ #0,D7                   Longueur de la chane=1
         MOVE.B D1,2(A3)               Premier caractre
LPGETWD  MOVEQ #INFINITE,D3            Saisie d'un caractre
         MOVEQ #JOB_CURR,D1
         MOVEQ #IO.FBYTE,D0
         TRAP #3
         TST D0
         BNE.S EXITGET
         ADDQ #1,D7
         MOVE.B D1,2(A3,D7)
         LEA STOPS,A2        Le caractre est-il un caractre d'arrt ?
CHARSTOP CMP.B (A2),D1
         BEQ.S WORDFOUN
         CMPI.B #END_MARK,(A2)+
         BEQ.S LPGETWD
         BRA.S CHARSTOP

WORDFOUN MOVE D7,(A3)
         MOVEA.L A3,A1
EXITGET  RTS

**********************************
** Table des caractres d'arrt **
**********************************

STOPS    DC.B 1,2,3,4,5,6
         DC.B 7,8,9,10,11,12
         DC.B 13,14,15,16,17,18
         DC.B 19,20,21,22,23,24
         DC.B 25,26,27,28,29,30
         DC.B 31,' .;:,'
         DC.B 39,'-%()"',END_MARK
         DC.B 10

*********************************************
** Insertion d'un mot dans le dictionnaire **
*********************************************

INSERT   SUBA.L A6,A1                  Rend A1 relatif  A6
         MOVEA.L POINTBT(A6),A2        Base de la recherche dichotomique
         MOVEA.L LASTPOIN(A6),A3       Haut de la dichotomie
NEXTSEAR MOVE.L A3,D0
         SUB.L A2,D0
         LSR.L #1,D0                   Calcule le milieu de la table
         AND #$FFFC,D0                 Arrondi aux 4 infrieurs
         MOVEA.L A2,A4
         ADDA.L D0,A4                  Calcule de l'adresse du milieu de la table
         CMPA.L A2,A4                  Milieu gal au dbut (plus de place)
         BEQ.S SHIFTTAB                  ->dcale la table
         MOVEA.L (A4),A0               Adresse de la chane (relative  A6)
         MOVEQ #STRGCOMP,D0            Compare les chane
         MOVEA UT.CSTR,A5
         JSR (A5)
         TST D0                        Rsultat ?
         BEQ.S RETBUILD                Si gales -> retour
         BLT.S BEGPOINT
         MOVEA.L A4,A3                 Moiti infrieure
         BRA.S NEXTSEAR

BEGPOINT MOVEA.L A4,A2                 Moiti suprieure
         BRA.S NEXTSEAR

SHIFTTAB MOVEA.L POINTBT(A6),A4
         MOVEA.L A4,A5
         SUBQ #4,A4
         MOVE.L A4,POINTBT(A6)
SHIFTLP  MOVE.L (A5)+,(A4)+            Dcale la table pour crer une nouvelle entre
         CMPA.L A2,A5
         BLE.S SHIFTLP
         MOVE.L A1,(A4)                Stocke l'adresse de la chane dans la table
         ADDA.L A6,A1                  Calcule A1 absolu
         ADDA (A1),A1
         MOVE.L A1,D0
         ADDQ.L #3,D0
         BCLR #0,D0
         MOVE.L D0,STRINGTP(A6)        Sauve la nouvelle adresse de la chane
         ADDQ #1,WORDNUM(A6)           Un mot de plus
RETBUILD RTS

********************************
** IMPRESSION DU DICTIONNAIRE **
********************************

WRITEDIC LEA WRTDICTX,A5
         BSR DISPNAME
         MOVEA.L POINTBT(A6),A2        Pointe le bas des pointeurs
         ADDQ #4,A2                    Saute le mot vide
         MOVEQ #INFINITE,D3
WRTDICLP MOVEA.L (A2)+,A1              Chane  imprimer
         ADDA.L A6,A1                  Rendue absolue
         MOVEA UT.MTEXT,A5
         JSR (A5)                      Stockage dans le fichier
         TST D0                        Erreur ?
         BNE EXIT                        oui->sortie
         MOVEQ #LINEFEED,D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         TST D0                        Erreur ?
         BNE EXIT                        oui ->sortie
         CMPA.L LASTPOIN(A6),A2
         BLT.S WRTDICLP
         RTS

WRTDICTX DC.W 25
         DC.B 'Ecriture du dictionnaire',LINEFEED,0

*************************
** ROUTINES DE SERVICE **
*************************

* Sortie d'une routine aprs erreur

EXIT     EXT.L D0
         MOVEA UT.ERR,A2               Affichage du message d'erreur ventuel)
         MOVEA.L CONSOLID(A6),A0
         JSR (A2)
         MOVEA.L A6,SP                 Rtablit la pile
         MOVEA.L FILEIN(A6),A0
         MOVEQ #IO.CLOSE,D0
         TRAP #2
         MOVEA.L FILEOUT(A6),A0
         MOVEQ #IO.CLOSE,D0
         TRAP #2
         BRA MAINLOOP

*
* Ouverture du fichier de travail
* Registres modifis:D7 (copie de A0),A1,A5
* A0=identificateur

EXITOPEN RTS                 La sortie avant l'entre !

OPENFILE MOVE.L A0,D7
         MOVE.L D3,D4
OPENFIL2 MOVEQ #JOB_CURR,D1
         MOVEQ #IO.OPEN,D0
         TRAP #2
         TST D0              Pas d'erreur ?
         BEQ.S EXITOPEN         -> retour
         CMP #ERR.EX,D0      Already exists ?
         BNE.S EXIT            non ->sortie
         MOVEA.L CONSOLID(A6),A0
         MOVEA.L D7,A1
         MOVEA UT.MTEXT,A5
         JSR (A5)
         LEA ALEXTEXT,A1
         JSR (A5)
         MOVEQ #INFINITE,D3
         MOVEQ #SD.CURE,D0
         TRAP #3
         MOVEQ #IO.FBYTE,D0
         TRAP #3
         MOVE D1,D2
         MOVEQ #SD.CURS,D0
         TRAP #3
         CMP.B #'O',D2
         BEQ.S OVERFILE
         CMP.B #'o',D2
         BNE EXIT
OVERFILE MOVEA.L D7,A0
         MOVEQ #JOB_CURR,D1
         MOVEQ #IO.DELET,D0
         TRAP #2
         TST D0
         BNE EXIT
         MOVEA.L D7,A0
         MOVE.L D4,D3
         BRA.S OPENFIL2

ALEXTEXT DC.W 34
         DC.B ' existe dj',LINEFEED
         DC.B 'remplacement (o/n) ?',LINEFEED

* Sortie si non EOF

EXITBUIL CMP #ERR.EF,D0
         BNE EXIT
         RTS

* Initialise les pointeurs pour les listes de mots

INILIST  MOVEM.L A0-A1,-(SP)
         LEA RESDITEX,A5
         BSR DISPNAME
         CLR WORDNUM(A6)     Zro mot
         MOVE.L WORKSPAC(A6),STRINGTP(A6)
         MOVEA.L POINTADR(A6),A0
         MOVEA.L STRINGTP(A6),A1       Pointeur de chanes
         SUBA.L A6,A1                  Rend A1 relatif  A6
         MOVE.L #$0002FFFF,0(A6,A1.L)  Chane FFFF (plus grande chane possible)
         MOVE.L A1,-(A0)               Pointe
         ADDQ #4,A1                    Pointe le dbut de la chane suivante
         MOVE.L A1,-(A0)               Pointe
         MOVE.L A0,POINTBT(A6)         Sauve le pointeur
         LEA 0(A6,A1.L),A1             Calcule A1 absolu
         CLR (A1)+                     Chane vide
         MOVE.L A1,STRINGTP(A6)        Sauve le pointeur de chanes
         MOVEM.L (SP)+,A0-A1           Restitue les Id.
         RTS                           Retour

RESDITEX DC.W 17
         DC.B 'RAZ dictionnaire',LINEFEED,0

* Demande le nom du dictionnaire et charge

QUERYDIC MOVEA.L CONSOLID(A6),A0
         LEA QUEDITEX,A1
         MOVEA UT.MTEXT,A5
         JSR (A5)
         LEA FILENAME+2(A6),A1
         MOVEQ #MAXLEN,D2
         MOVEQ #INFINITE,D3
         MOVEQ #IO.FLINE,D0
         TRAP #3
         SUBQ #1,D1                    Supprime le LINEFEED
         MOVE D1,FILENAME(A6)          Stocke la longueur
         TST D0
         BNE EXIT
         CMPI.L #$0001210A,FILENAME(A6)          Si !
         BEQ EXIT                                  ->retour
         TST FILENAME(A6)
         BEQ.S RETQUEDI
         LEA DICO(A6),A1
         LEA FILENAME(A6),A0
         MOVE (A0)+,D1
         MOVE D1,(A1)+
         SUBQ #1,D1
         LSR #1,D1
NAMELOOP MOVE (A0)+,(A1)+
         DBRA D1,NAMELOOP
         LEA FILENAME(A6),A0
         MOVEQ #JOB_CURR,D1
         MOVEQ #IO.SHARE,D3
         MOVEQ #IO.OPEN,D0
         TRAP #2
         TST D0
         BEQ UNPACK
         CMP #ERR.NF,D0
         BEQ INILIST
         BRA EXIT

RETQUEDI RTS

QUEDITEX DC.W 32
         DC.B 'Dictionnaire ? (<ENTER>=courant)'

* Demande le nom du fichier et ouvre (type dans D7)

QUERYFIL MOVEA.L CONSOLID(A6),A0
         MOVEA UT.MTEXT,A5
         JSR (A5)
         LEA FILENAME+2(A6),A1
         MOVEQ #MAXLEN,D2
         MOVEQ #INFINITE,D3
         MOVEQ #IO.FLINE,D0
         TRAP #3
         TST D0
         BNE EXIT
         SUBQ #1,D1                    Supprime le LINEFEED
         MOVE D1,FILENAME(A6)          Stocke la longueur
         CMPI.L #$0001210A,FILENAME(A6)          Si !
         BEQ EXIT                                  ->retour
         LEA FILENAME(A6),A0
         MOVE.L D7,D3
         BRA OPENFILE

RETQUEFI RTS

*****************************
** Impression d'une chane **
*****************************

PRTSTR   MOVE.L A0,-(SP)     Empile l'identificateur de fichier
         MOVEA.L FILEOUT(A6),A0
         MOVE D7,D2
         MOVEA.L A3,A1
         MOVEQ #INFINITE,D3
         MOVEQ #IO.SSTRG,D0
         TRAP #3
         MOVEQ #10,D1
         MOVEQ #IO.SBYTE,D0
         TRAP #3
         MOVEA.L (SP)+,A0
         RTS

* Sortie sans erreur si EOF

EXITNEOF CMP #ERR.EF,D0
         BNE EXIT
EXITERR  RTS

* Affichage du nom de la routine en cours d'excution

DISPNAME MOVEM.L A0-A1,-(SP)
         MOVEA.L A5,A1
         MOVEA.L CONSOLID(A6),A0
         MOVEA UT.MTEXT,A5
         JSR (A5)
         TST D0
         BNE EXIT
         MOVEM.L (SP)+,A0-A1
         RTS

* Rafrachissement de l'cran

REFRESH  MOVEA.L CONSOLID(A6),A0
         MOVEQ #INFINITE,D3
         MOVEQ #4,D1
         MOVEQ #1,D2
         MOVEQ #SD.BORDR,D0
         TRAP #3
         MOVEQ #SD.CLEAR,D0
         TRAP #3
         BRA MAINLOOP

         DATA ENDVAR+1024

         END
